/* AP 10-sep-12 hanoi.c				*/
/*		Tuerme von Hanoi		*/

# include <stdio.h>

void ziehe_scheibe(int nummer, char * von, char * nach) {
	printf("Scheibe %d wird von %s nach %s verschoben\n",
		 nummer, von, nach);
}

void hanoi(int N, char * platz1, char * hilfsplatz, char * platz2) {
	if (N == 1)
      		ziehe_scheibe(N, platz1, platz2);
 	else {
      		hanoi(N-1, platz1, platz2, hilfsplatz);
      		ziehe_scheibe(N, platz1, platz2); 
      		hanoi(N-1, hilfsplatz, platz1, platz2);
	}
}

int main(int argc, char * argv[]) {
	char * prog = argv[0];
	int N;

	if (argc < 2) {
		fprintf(stderr, "usage: %s <hoehe>\n", prog );
		return 1;
	}
	N = atoi( argv[1] );
	hanoi(N, "A", "B", "C");
}

