/* AP 10-sep-12	nim.c					*/
/*		eine Demo-Fassung des NIM-Spiels	*/

# include <stdio.h>

static int reihe1 = 0, reihe2 = 0, reihe3 = 0;  
static int zugnummer = 0;
static int spieler = 1;
static int fertig = 0;

void init() { 
 	reihe1 = 3; reihe2 = 5; reihe3 = 4;
	zugnummer = 0;
	spieler = 1;
	fertig = 0;
}

void zeige_spiel() { 
 	/* Ausgabe des Spielfelds auf die Standardausgabe */ 
	printf("Spieler %d, Zug %d: "
		"Reihe 1: %d, Reihe 2: %d, Reihe 3: %d\n",
		spieler, zugnummer, reihe1, reihe2, reihe3 );
}

int spiel_ende() {
	/* Das Spiel ist zu Ende wenn es keine Steine mehr gibt */
 	return reihe1+reihe2+reihe3 == 0;
}

void spielerwechsel() {
	spieler = (spieler == 1) ? 2 : 1;
}

void gratuliere_dem_sieger() { 
	/* gewonnen hat, wer den letzten Zug gemacht hat; */
	/* dieser Wert ist noch in Variable spieler gespeichert */
	printf("Gewonnen hat Spieler %d\t", spieler );
	printf("Herzlichen Glückwunsch\n" );
}

void verlegenheitszug() {
	if (reihe1) reihe1--;
	else if (reihe2) reihe2--;
	else if (reihe3) reihe3--;
}

void mache_zug() {
 	zugnummer += 1;
 	if (reihe1 > (reihe2 ^ reihe3)) 
      		reihe1 = reihe2 ^ reihe3; 
 	else if (reihe2 > (reihe1 ^ reihe3)) 
      		reihe2 = reihe1 ^ reihe3;
 	else if (reihe3 > (reihe1 ^ reihe2)) 
      		reihe3 = reihe1 ^ reihe2;
 	else 
      		verlegenheitszug();
}


int main() {
	init(); 
	while ( ! fertig ) { 
 		zeige_spiel(); 
 		mache_zug(); 
 		if ( spiel_ende())
     			fertig = 1; 
 		else 
     			spielerwechsel();
	} 
	gratuliere_dem_sieger(); 
}


